I’m not really understanding why sometimes the faces are correct like picture 1 and sometimes they are not correct like picture 2.
pic 1
pic2
example of the issue
code
SKETCHUP_CONSOLE.clear
Sketchup.file_new
# Default code, use or delete...
mod = Sketchup.active_model # Open model
ent = mod.entities # All entities in model
sel = mod.selection # Current selection
group = ent.add_group
trimmer_group = ent.add_group
face = group.entities.add_face [0,0,0],[0,10,0],[10,10,0],[10,0,0]
face.reverse! unless face.normal.z == 1
edges_to_follow = face.edges
e1_dir = edges_to_follow[0].line[1]
min_v = [0,0,0]
d = 1
z = 1
o = 0
cut_vector = [-d,d,-z-o]
up_vector = [d,d,z-o]
down_vector = [d,d,-z-o]
trim_vector = [-d,d,z-o]
p " e1 direction = #{e1_dir}"
trimmer_pts = [ min_v.offset(cut_vector),min_v.offset(trim_vector),min_v.offset(up_vector),min_v.offset(down_vector)]
trim_face = trimmer_group.entities.add_face trimmer_pts
p " trim_face direction = #{trim_face.normal}"
trim_face.reverse! unless trim_face.normal.samedirection?(e1_dir)
p " trim_face direction = #{trim_face.normal}"
trim_face.followme edges_to_follow
pts = [ min_v.offset(cut_vector),min_v.offset(down_vector),min_v.offset(up_vector)]
# add cut face
cut = group.entities.add_face pts
p " cut direction = #{cut.normal}"
# make cut face follow edges
cut.reverse! unless cut.normal.samedirection?(e1_dir)
p " cut direction = #{cut.normal}"
cut.followme edges_to_follow